function ATmat = Adraw(BTmat,lSigTmat,S)
% Draws a new covariance state using Primiceri's (2005) adaptation of the
% Carter-Kohn algorithm.

global ydata xdata T muA scaleA

Attmat1 = zeros(1,T);

Pttmat1 = zeros(1,T);

Att1 = muA(1);

Ptt1 = scaleA(1,1);

S1 = S(1,1);

umat = zeros(T,3);

for t = 1:T
    
    yt = ydata(t,:)';
    
    Xpt = kron(eye(3),xdata(t,:));
    
    Bt = BTmat(:,t);
    
    ut = yt - Xpt*Bt;
    
    umat(t,:) = ut';
    
    ugt = ut(2);
    
    Z1t = -ut(1);
    
    siggt = exp(lSigTmat(2,t));
    
    Atl1 = Att1;
    
    Ptl1 = Ptt1 + S1;
    
    Kt1 = Ptl1*Z1t'/(Z1t*Ptl1*Z1t'+siggt^2);
    
    Att1 = Atl1 + Kt1*(ugt-Z1t*Atl1);
    
    Ptt1 = Ptl1 - Kt1*Z1t*Ptl1;
    
    Attmat1(1,t) = Att1;
    
    Pttmat1(1,t) = Ptt1;
    
end

ATmat = zeros(3,T);

A1 = Attmat1(1,T);

VVp1 = Pttmat1(1,T);

ATmat(1,T) = mvndraw(A1,VVp1);

for j = 1:T-1
    
    Att1 = Attmat1(1,T-j);
    
    Ptt1 = Pttmat1(1,T-j);
    
    A1 = Att1 + Ptt1/(Ptt1+S1)*(ATmat(1,T-j+1)-Att1);
    
    VVp1 = Ptt1 - Ptt1/(Ptt1+S1)*Ptt1;
    
    ATmat(1,T-j) = mvndraw(A1,VVp1);
    
end

Attmat2 = zeros(2,T);

Pttmat2 = zeros(4,T);

Att2 = muA(2:3);

Ptt2 = scaleA(2:3,2:3);

S2 = S(2:3,2:3);

for t = 1:T
    
    urt = umat(t,3);
    
    Z2t = -umat(t,1:2);
    
    sigrt = exp(lSigTmat(3,t));
    
    Atl2 = Att2;
    
    Ptl2 = Ptt2 + S2;
    
    Kt2 = Ptl2*Z2t'/(Z2t*Ptl2*Z2t'+sigrt^2);
    
    Att2 = Atl2 + Kt2*(urt-Z2t*Atl2);
    
    Ptt2 = Ptl2 - Kt2*Z2t*Ptl2;
    
    Attmat2(:,t) = Att2;
    
    Pttmat2(:,t) = Ptt2(:);
    
end

A2 = Attmat2(:,T);

VVp2 = reshape(Pttmat2(:,T),2,2);

ATmat(2:3,T) = mvndraw(A2,VVp2);

for j = 1:T-1
    
    Att2 = Attmat2(:,T-j);
    
    Ptt2 = reshape(Pttmat2(:,T-j),2,2);
    
    A2 = Att2 + Ptt2/(Ptt2+S2)*(ATmat(2:3,T-j+1)-Att2);
    
    VVp2 = Ptt2 - Ptt2/(Ptt2+S2)*Ptt2;
    
    ATmat(2:3,T-j) = mvndraw(A2,VVp2);
    
end

