function BTmat = Bdraw(ATmat,lSigTmat,Q)
% Draws a new coefficient state using the Carter-Kohn algorithm.

global ydata xdata q T Ra ra muB scaleB

Bttmat = zeros(3+9*q,T);

Pttmat = zeros((3+9*q)^2,T);

Btt = muB;

Ptt = scaleB;

for t = 1:T
    
    yt = ydata(t,:)';
    
    Xpt = kron(eye(3),xdata(t,:));
        
    Atvec = Ra*ATmat(:,t) + ra;
        
    At = reshape(Atvec,3,3);
               
    Sigt = diag(exp(lSigTmat(:,t)));
    
    AinvSigt = At\Sigt;
    
    Omegat = AinvSigt*AinvSigt';
    
    Btl = Btt;
    
    Ptl = Ptt + Q;
    
    Kt = Ptl*Xpt'/(Xpt*Ptl*Xpt'+Omegat);
    
    Btt = Btl + Kt*(yt-Xpt*Btl);
    
    Ptt = Ptl - Kt*Xpt*Ptl;
    
    Bttmat(:,t) = Btt;
    
    Pttmat(:,t) = Ptt(:);
    
end

BTmat = zeros(3+9*q,T);
    
B = Bttmat(:,T);

VVp = reshape(Pttmat(:,T),3+9*q,3+9*q);

BTmat(:,T) = mvndraw(B,VVp);

for j = 1:T-1
    
    Btt = Bttmat(:,T-j);
    
    Ptt = reshape(Pttmat(:,T-j),3+9*q,3+9*q);
    
    B = Btt + Ptt/(Ptt+Q)*(BTmat(:,T-j+1)-Btt);
    
    VVp = Ptt - Ptt/(Ptt+Q)*Ptt;
        
    BTmat(:,T-j) = mvndraw(B,VVp);
    
end
