function imps = impulses(Bvec,Cmat,Dmat,j)
% Generates impulse responses of inflation, the gap variable, and the
% nominal interest rate to shock j.

global q

Bmat = reshape(Bvec,1+3*q,3);

BigB = [ Bmat(2:1+3*q,:)' ; eye(3*(q-1)) zeros(3*(q-1),3) ];

F = [ Cmat\Dmat ; zeros(3*(q-1),3) ];

epgr = [ eye(3) zeros(3,3*(q-1)) ];

imps = zeros(41,3);

evec = zeros(3,1);
evec(j) = 1;

yt = F*evec;

imps(2,:) = (epgr*yt)';

for t = 3:41
    
    yt = BigB*yt;
    
    imps(t,:) = (epgr*yt)';
    
end