function mvN = mvndraw(mu,VVp)
% Draws from the multivariate normal distribution with mean mu and
% covariance matrix VVp.

k = length(mu);

[ V,p ] = chol(VVp,'lower');

if p == 0
    
     mvN = mu + V*randn(k,1);

else
  
    [ W,D ] = eig((VVp+VVp')/2);
    
    d = diag(D);
    eee = eps(max(d))*k;
    j = (abs(d) > eee);
    d = d(j);
    k = length(d);
    
    if (sum(d<0)==0)
        
        D = diag(sqrt(d));
        W = W(:,j);
        V = W*D;
        
        mvN = mu + V*randn(k,1);
        
    else
        
        error(message('mvndraw: covariance matrix is not positive semidefinite'));
        
    end
            
end