function decomps = vardecomp(Bvec,Cmat,Dmat,j)
% Computes percentages of forecast error variances in inflation, the gap
% variable, and the nominal interest rate due to shock j.

global q

Bmat = reshape(Bvec,1+3*q,3);

BigB = [ Bmat(2:1+3*q,:)' ; eye(3*(q-1)) zeros(3*(q-1),3) ];

F = [ Cmat\Dmat ; zeros(3*(q-1),3) ];

Dmatshock = zeros(3,3);
Dmatshock(j,j) = Dmat(j,j);

Fshock = [ Cmat\Dmatshock ; zeros(3*(q-1),3) ];

decomps = zeros(40,3);

TkVAR = F*F';
TkVARshock = Fshock*Fshock';

decomps(1,1) = 100*TkVARshock(1,1)/TkVAR(1,1);
decomps(1,2) = 100*TkVARshock(2,2)/TkVAR(2,2);
decomps(1,3) = 100*TkVARshock(3,3)/TkVAR(3,3);

BigBk = eye(3*q);

for k = 2:40
    
    BigBk = BigBk*BigB;
    
    TkVAR = TkVAR + BigBk*(F*F')*BigBk';
    TkVARshock = TkVARshock + BigBk*(Fshock*Fshock')*BigBk';
    
    decomps(k,1) = 100*TkVARshock(1,1)/TkVAR(1,1);
    decomps(k,2) = 100*TkVARshock(2,2)/TkVAR(2,2);
    decomps(k,3) = 100*TkVARshock(3,3)/TkVAR(3,3);

end